/* This lot of code is half made up from Mozilla.org's Midas demo (http://www.mozilla.org/editor/midasdemo/)
   and Netscape DevEdge's demo of the control also (http://devedge.netscape.com/viewsource/2003/midas/01/).
   Bits have been changed here and there to get it to work the way I'm trying to implement it */

var sourceview = false;

function SetUpMidas(){
	// This is to send the iframe into RTF editing mode.
	getIFrameDocument("message").designMode = "On";
	document.getElementById("message").contentWindow.document.execCommand("useCSS", false, !usecss);
	document.getElementById("message").contentWindow.focus();
}
    
function MakeBlank() {
	// This is to blank out the iframe, for if a post has been sent succesfully or whatever.
	var F = document.getElementById("message").contentWindow;
	F.document.body.innerHTML = "";
	if (document.getElementById("tabsource").selected) {
		document.getElementById("messagesource").focus();
	} else {
		F.focus();
	}
}

// Next few are nicked from Netscape's Midas Demo.
function getIFrameDocument(aID){
	if (document.getElementById(aID).contentDocument){  
		return document.getElementById(aID).contentDocument;
	} else {
		return document.frames[aID].document;
	}
}
     
function doRichEditCommand(aName, aArg){
	getIFrameDocument("message").execCommand(aName,false, aArg);
	document.getElementById("message").contentWindow.focus()
} 
        
function addLink(){
	var myUrl = prompt("Please enter a URL:", "");
	getIFrameDocument("message").execCommand("createLink", false, myUrl);
}    

function addImage() {
		var myImage = prompt("Please enter the URL of an image:","");
	    getIFrameDocument("message").execCommand("insertimage", false, myImage);
	}

function FixWrapping(wrapped) {
	// Midas sticks a newline in every 70 - 160 characters or so, as a source formatting thing. This wrecks LiveJournal
	// posts, which by default, format all newline characters as a <br>. This causes your post to take up like 1/3 of
	// the screen over to the left. This fixes it. Hopefully.
	wrapped = wrapped.replace(/<br>\r\n/gi,"<br>");
	wrapped = wrapped.replace(/\r\n/gi," ");
	wrapped = wrapped.replace(/\r/gi," ");
	wrapped = wrapped.replace(/\n/gi," ");
	wrapped = wrapped.replace(/<br>/gi,"\n");
	return wrapped.trim();
}

function FixLJTags(ljtext, toents) {
	// This is so Midas doesn't bugger up LiveJournal's specific tags (they start with <lj>)... It'll render them as they look
	// in source view.
	if (toents) {
		ljtext = ljtext.replace(/<(\/?lj[^>]*)>/gi, "&lt;$1&gt;");
	} else {
		// This part is really icky, but I seriously couldn't figure out how to do a regexp to do the opposite of above, and everyone
		// deserted me when I asked how.
		var ljarray = ljtext.split("&gt;");
		var ljtemp;
		for (i = 0; i < ljarray.length; i++) {
			ljtemp = ljarray[i].replace(/&lt;(\/?lj.*)/gi, "<$1");
			if (i < ljarray.length -1) {
				if (ljtemp != ljarray[i]) {
					ljtemp += ">";
				} else {
					ljtemp += "&gt;";
				}
			}
			ljarray[i] = ljtemp;
		}
	ljtext = ljarray.join("");
	}
	return ljtext;
}

function ViewSource(tabname) {
	// To move between textbox and iframe. The 'sourceview' thing is to stop it blanking the post if you click
	// the same tab that you're already on. (ie. if you're in source view and click the 'source' tab)
	if ((document.getElementById("messagetabbox").selectedIndex == 1) && !sourceview) {
		var textbit = document.getElementById("message").contentWindow.document.body.innerHTML;
		if (!dontautoformat) {
			textbit = FixWrapping(textbit);
		}
		textbit = FixLJTags(textbit, false);
	    var html = document.createTextNode(textbit);
	   	document.getElementById("message").contentWindow.document.body.innerHTML = "";
		document.getElementById("messagesource").value = textbit;
		sourceview = true;
	} else if ((document.getElementById("messagetabbox").selectedIndex == 0) && sourceview) {
		var html = document.getElementById("messagesource").value;
		if (!dontautoformat) {
			html = html.replace(/\n/gi,"<br>");
		}
		html = FixLJTags(html, true);
		document.getElementById("message").contentWindow.document.body.innerHTML = html;
		sourceview = false;
	}
}